## dde-dock 6.0.37

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

if (NOT DEFINED VERSION)
    set(VERSION 6.0.37)
endif()

project(dde-dock)

find_package(DtkTools REQUIRED)

set(CMAKE_THREAD_LIBS_INIT "-lpthread")
set(CMAKE_HAVE_THREADS_LIBRARY 1)
set(CMAKE_USE_PTHREADS_INIT 1)
set(CMAKE_PREFER_PTHREAD_FLAG ON)

#set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall")

# 增加安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -fPIE")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")
endif()

# generate a compile commands file as complete database for vim-YouCompleteMe or some other similar tools
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()
include(GNUInstallDirs)

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")

    # generate qm
    execute_process(COMMAND bash "translate_generation.sh"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif ()

set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DQT_DEBUG")

# Test architecture
if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    # add compiler flags -mieee for mathmatic
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
    add_definitions(-DDISABLE_SHOW_ANIMATION)
endif()

function(generation_dbus_interface xmldir outdir)
    IF(EXISTS ${outdir})
        file(REMOVE_RECURSE ${outdir})
    ENDIF()
    execute_process(COMMAND ${CMAKE_COMMAND} -E make_directory ${outdir})
    file(GLOB_RECURSE allXmls ${xmldir}/*.xml)
    foreach(XMLFILE ${allXmls})
        string(FIND ${XMLFILE} "/" INDEX REVERSE)
        string(SUBSTRING ${XMLFILE} ${INDEX} -1 classname)
        string(REPLACE "/" "" classname ${classname})
        string(REPLACE ".xml" "" classname ${classname})
        string(REPLACE "." "_" classname ${classname})
        string(TOLOWER ${classname} filename)

        execute_process(COMMAND ${DTK_XML2CPP} -c ${classname} -p ${outdir}/${filename} ${XMLFILE}
            WORKING_DIRECTORY ${outdir})
    endforeach()
endfunction(generation_dbus_interface)

file(GLOB INTERFACES "interfaces/*.h")
add_definitions(-DCVERSION="${VERSION}")
#因为单元测试需要直接测试源代码，而主程序代码中include的单元使用了相对路径
#单元测试的CMakeLists和主程序的CMakeLists路径不同，编译单元测试时会提示找不到文件
#因此设置搜索路径
include_directories(
    frame/accessible
    frame/controller
    frame/dbus
    frame/dbus/sni
    frame/display
    frame/item
    frame/item/components
    frame/item/resources
    frame/model
    frame/util
    frame/window
    frame/window/components
    frame/window/tray
    frame/window/tray/widgets
    frame/xcb
    ../widgets
    ../interfaces
    )
aux_source_directory(frame/accessible ACCESSIBLE)
aux_source_directory(frame/controller CONTROLLER)
aux_source_directory(frame/dbus DBUS)
aux_source_directory(frame/dbus/sni SNI)
aux_source_directory(frame/display DISPLAY)
aux_source_directory(frame/item ITEM)
aux_source_directory(frame/model MODEL)
aux_source_directory(frame/item/components ITEMCOMPONENTS)
aux_source_directory(frame/item/resources RESOURCES)
aux_source_directory(frame/util UTIL)
aux_source_directory(frame/window WINDOW)
aux_source_directory(frame/window/components WINDOWCOMPONENTS)
aux_source_directory(frame/window/tray WINDOWTRAY)
aux_source_directory(frame/window/tray/widgets WINDOWTRAYWIDGET)
aux_source_directory(frame/xcb XCB)

file(GLOB SRC_PATH
    ${ACCESSIBLE}
    ${CONTROLLER}
    ${DBUS}
    ${SNI}
    ${DISPLAY}
    ${ITEM}
    ${MODEL}
    ${ITEMCOMPONENTS}
    ${UTIL}
    ${WINDOW}
    ${WINDOWCOMPONENTS}
    ${WINDOWTRAY}
    ${WINDOWTRAYWIDGET}
    ${XCB}
    )

add_subdirectory("frame")
add_subdirectory("plugins")
#add_subdirectory("tests")

## qm files
file(GLOB QM_FILES "translations/*.qm")
install(FILES ${QM_FILES}
    DESTINATION share/dde-dock/translations)

## dev files
install(FILES ${INTERFACES}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dde-dock)

configure_file(dde-dock.pc.in dde-dock.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/dde-dock.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/DdeDock/DdeDockConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/DdeDockConfig.cmake
    @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/DdeDockConfig.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeDock)

install(FILES gschema/com.deepin.dde.dock.module.gschema.xml
    DESTINATION ${CMAKE_INSTALL_DATADIR}/glib-2.0/schemas)

#dconfig
file(GLOB DCONFIG_FILES "configs/*.json")
install(FILES ${DCONFIG_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/dsg/configs/dde-dock/)

# Address Sanitizer 内存错误检测工具,打开下面的编译选项可以看到调试信息，正常运行时不需要这些信息
#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O2")
#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O2")

=== frame/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

set(BIN_NAME dde-dock)

configure_file(environments.h.in environments.h @ONLY)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O0")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O0")
endif()

generation_dbus_interface(${CMAKE_CURRENT_SOURCE_DIR}/dbusinterface/xml ${CMAKE_CURRENT_SOURCE_DIR}/dbusinterface/generation_dbus_interface)

# Sources files
file(GLOB_RECURSE SRCS "*.h" "*.cpp" "../widgets/*.h" "../widgets/*.cpp" "../interfaces/*.h")

# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(Qt5X11Extras REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5WaylandClient REQUIRED)
find_package(Qt5XkbCommonSupport REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkCMake REQUIRED)
find_package(dbusmenu-qt5 REQUIRED)
find_package(ECM REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
find_package(DWayland REQUIRED)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

pkg_check_modules(XCB_EWMH REQUIRED IMPORTED_TARGET x11 xcb xcb-icccm xcb-image xcb-ewmh xcb-composite xtst dbusmenu-qt5 xext xcursor xkbcommon xres)
pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)
pkg_check_modules(WAYLAND REQUIRED IMPORTED_TARGET wayland-client wayland-cursor wayland-egl)

# driver-manager
add_executable(${BIN_NAME}
    ${SRCS}
    ${INTERFACES}
    ${SRC_PATH}
    item/item.qrc)

target_include_directories(${BIN_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${PROJECT_BINARY_DIR}
    ${Qt5WaylandClient_PRIVATE_INCLUDE_DIRS}
    ../interfaces
    ../widgets
    ./dbusinterface/generation_dbus_interface
    ./qtdbusextended/
    ./dbusinterface
    accessible
    controller
    dbus
    display
    item
    item/components
    model
    pluginadapter
    screenspliter
    util
    window
    window/components
    window/tray
    window/tray/widgets
    drag
    xcb
    ../plugins/tray
    ../plugins/show-desktop
    ../plugins/datetime
    ../plugins/onboard
    ../plugins/trash
    ../plugins/shutdown
    ../plugins/multitasking
    ../plugins/overlay-warning
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    PkgConfig::QGSettings
    PkgConfig::XCB_EWMH
    PkgConfig::WAYLAND
    Dtk::Gui
    Qt5::Widgets
    Qt5::Gui
    Qt5::Concurrent
    Qt5::X11Extras
    Qt5::DBus
    Qt5::Svg
    Qt5::WaylandClient
    Qt5::XkbCommonSupport
    DWaylandClient
    Threads::Threads
    -lm
)

if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "sw_64")
    target_compile_definitions(${BIN_NAME} PUBLIC DISABLE_SHOW_ANIMATION)
endif()

if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "mips64")
    target_compile_definitions(${BIN_NAME} PUBLIC DISABLE_SHOW_ANIMATION)
endif()

if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
    target_compile_definitions(${BIN_NAME} PUBLIC DISABLE_SHOW_ANIMATION)
endif()

# bin
install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
# window_patterns
install(FILES taskmanager/window_patterns.json DESTINATION ${CMAKE_INSTALL_DATADIR}/dde-dock/)

=== plugins/CMakeLists.txt ===
add_subdirectory("shutdown")
add_subdirectory("power")
add_subdirectory("sound")
add_subdirectory("display")
add_subdirectory("media")
add_subdirectory("pluginmanager")
add_subdirectory("trash")
add_subdirectory("keyboard-layout")
add_subdirectory("onboard")
add_subdirectory("overlay-warning")
add_subdirectory("show-desktop")
add_subdirectory("multitasking")
add_subdirectory("bluetooth")
add_subdirectory("airplane-mode")
add_subdirectory("notification")

=== tests/CMakeLists.txt ===
ADD_COMPILE_OPTIONS(-fno-access-control)

cmake_minimum_required(VERSION 3.16)

set(BIN_NAME dde_dock_unit_test)

# 自动生成moc文件
set(CMAKE_AUTOMOC ON)

# 源文件
file(GLOB_RECURSE SRCS
    "*.h"
    "*.cpp"
    "../widgets/*.h"
    "../widgets/*.cpp")

list(REMOVE_ITEM SRCS "plugins/dcc-dock-settings-plugin/*.cpp")

# Sources files
file(GLOB_RECURSE PLUGIN_SRCS
    "../plugins/bluetooth/*.h"
    "../plugins/bluetooth/*.cpp"
    "../plugins/bluetooth/componments/*.h"
    "../plugins/bluetooth/componments/*.cpp"
    #"../plugins/dcc-dock-plugin/*.h"
    #"../plugins/dcc-dock-plugin/*.cpp"
    "../frame/util/horizontalseperator.h"
    "../frame/util/horizontalseperator.cpp")


# 其包含的"interface/moduleinterface.h"文件中定义了ModuleInterface_iid，任务栏插件框架的interface文件中也有定义
#list(FILTER PLUGIN_SRCS EXCLUDE REGEX "../plugins/dcc-dock-plugin/settings_module.*")

# 用于测试覆盖率的编译条件
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O2")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O2")
endif()

# 查找gmock的cmake文件
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/tests/cmake/modules)

# 查找依赖库
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(Qt5X11Extras REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5 COMPONENTS Test REQUIRED)
#find_package(DdeControlCenter REQUIRED)
find_package(GTest REQUIRED)
find_package(GMock REQUIRED)
find_package(dbusmenu-qt5 REQUIRED)

pkg_check_modules(QGSettings REQUIRED gsettings-qt)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
pkg_check_modules(XCB_EWMH REQUIRED xcb-image xcb-composite xtst xcb-ewmh xext dbusmenu-qt5 x11 xcursor)

# 添加执行文件信息
add_executable(${BIN_NAME}
    ${SRCS}
    ${INTERFACES}
    ${SRC_PATH}
    ${PLUGIN_SRCS}
    ../frame/item/item.qrc
    ut_res.qrc)

# 包含路径
target_include_directories(${BIN_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${XCB_EWMH_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    #${DdeControlCenter_INCLUDE_DIR}
    ../interfaces
    fakedbus
    ../plugins/bluetooth
    ../plugins/bluetooth/componments
    #../plugins/dcc-dock-plugin
)

# 链接库
target_link_libraries(${BIN_NAME} PRIVATE
    ${Qt5Test_LIBRARIES}
    ${XCB_EWMH_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${Qt5X11Extras_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    #${DdeControlCenter_LIBRARIES}
    ${GTEST_LIBRARIES}
    ${GMOCK_LIBRARIES}
    -lpthread
    -lm
)

add_custom_target(check)

add_custom_command(TARGET check
    COMMAND ./${BIN_NAME}
    )

add_dependencies(check ${BIN_NAME})

=== plugins/airplane-mode/CMakeLists.txt ===

set(PLUGIN_NAME "airplane-mode")

project(${PLUGIN_NAME})

generation_dbus_interface(${CMAKE_CURRENT_SOURCE_DIR}/dbusinterface/xml ${CMAKE_CURRENT_SOURCE_DIR}/dbusinterface/generation_dbus_interface)

# Sources files
file(GLOB_RECURSE SRCS "*.h"
    "*.cpp"
    "../../widgets/tipswidget.h"
    "../../widgets/tipswidget.cpp"
    "../../frame/util/imageutil.h"
    "../../frame/util/imageutil.cpp"
    "../../frame/qtdbusextended/*.h"
    "../../frame/qtdbusextended/*.cpp")

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)

pkg_check_modules(XCB_LIBS REQUIRED IMPORTED_TARGET xcursor)
pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} resources/airplane_mode.qrc)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ..)

target_include_directories(${PLUGIN_NAME} PUBLIC ${DtkWidget_INCLUDE_DIRS}
  ../../interfaces
  ../../widgets
  ../../frame
  ../../frame/util
  ../../frame/qtdbusextended
  ./dbusinterface/generation_dbus_interface)

target_link_libraries(${PLUGIN_NAME} PRIVATE
  ${DtkWidget_LIBRARIES}
  PkgConfig::QGSettings
  PkgConfig::XCB_LIBS
  Qt5::Widgets
  Qt5::DBus
  Qt5::Svg)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins)

=== plugins/bluetooth/CMakeLists.txt ===

set(PLUGIN_NAME "bluetooth")

project(${PLUGIN_NAME})

generation_dbus_interface(${CMAKE_CURRENT_SOURCE_DIR}/dbusinterface/xml ${CMAKE_CURRENT_SOURCE_DIR}/dbusinterface/generation_dbus_interface)

# Sources files
file(GLOB_RECURSE SRCS "*.h"
    "*.cpp"
    "../../widgets/tipswidget.h"
    "../../widgets/tipswidget.cpp"
    "../../frame/util/imageutil.h"
    "../../frame/util/imageutil.cpp"
    "../../frame/util/statebutton.h"
    "../../frame/util/statebutton.cpp"
    "../../frame/util/horizontalseperator.h"
    "../../frame/util/horizontalseperator.cpp"
    "../../frame/qtdbusextended/*.h"
    "../../frame/qtdbusextended/*.cpp")

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)

pkg_check_modules(XCB_LIBS REQUIRED IMPORTED_TARGET xcursor)
pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} resources/bluetooth.qrc)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../quick-trays)
target_include_directories(${PLUGIN_NAME} PUBLIC ${DtkWidget_INCLUDE_DIRS}
  ../../interfaces
  ../../frame
  ../../frame/qtdbusextended
  ./dbusinterface/generation_dbus_interface
  componments)

target_link_libraries(${PLUGIN_NAME} PRIVATE
  ${DtkWidget_LIBRARIES}
  PkgConfig::QGSettings
  PkgConfig::XCB_LIBS
  Qt5::Widgets
  Qt5::DBus
  Qt5::Svg)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins/quick-trays)

=== plugins/display/CMakeLists.txt ===

set(PLUGIN_NAME "display")

project(${PLUGIN_NAME})

generation_dbus_interface(${CMAKE_CURRENT_SOURCE_DIR}/dbusinterface/xml ${CMAKE_CURRENT_SOURCE_DIR}/dbusinterface/generation_dbus_interface)

# Sources files
file(GLOB_RECURSE SRCS "*.h" "*.cpp"
    "../../widgets/*.h"
    "../../widgets/*.cpp"
    "../../frame/util/imageutil.h"
    "../../frame/util/imageutil.cpp"
    "../../frame/util/statebutton.h"
    "../../frame/util/statebutton.cpp"
    "../../frame/util/horizontalseperator.h"
    "../../frame/util/horizontalseperator.cpp"
    "../../frame/qtdbusextended/*.h"
    "../../frame/qtdbusextended/*.cpp")

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)

pkg_check_modules(XCB_LIBS REQUIRED IMPORTED_TARGET xcursor)
pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} ./resource/display.qrc)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../quick-trays)
target_include_directories(${PLUGIN_NAME} PUBLIC ${DtkWidget_INCLUDE_DIRS}
  ../../interfaces
  ../../widgets
  ../../frame
  ../../frame/qtdbusextended
  ./dbusinterface/generation_dbus_interface
  componments)

target_link_libraries(${PLUGIN_NAME} PRIVATE
  ${DtkWidget_LIBRARIES}
  PkgConfig::QGSettings
  PkgConfig::XCB_LIBS
  Qt5::Widgets
  Qt5::DBus
  Qt5::Svg)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins/quick-trays)

=== plugins/keyboard-layout/CMakeLists.txt ===

set(PLUGIN_NAME "keyboard-layout")

project(${PLUGIN_NAME})

generation_dbus_interface(${CMAKE_CURRENT_SOURCE_DIR}/dbusinterface/xml ${CMAKE_CURRENT_SOURCE_DIR}/dbusinterface/generation_dbus_interface)

# Sources files
file(GLOB_RECURSE SRCS "*.h"
    "*.cpp"
    "../../frame/qtdbusextended/*.h"
    "../../frame/qtdbusextended/*.cpp")

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(Qt5DBus REQUIRED)

pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS})
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../)
target_include_directories(${PLUGIN_NAME} PUBLIC ${DtkWidget_INCLUDE_DIRS}
                                                 ../../interfaces
                                                 ./dbusinterface
                                                 ./dbusinterface/generation_dbus_interface
                                                 ../../frame/qtdbusextended)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    PkgConfig::QGSettings
    Qt5::Widgets
    Qt5::DBus
    Qt5::Svg)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins/)
install(FILES ./keybord_layout.json DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/dde-dock/indicator)

=== plugins/media/CMakeLists.txt ===

set(PLUGIN_NAME "media")

project(${PLUGIN_NAME})

generation_dbus_interface(${CMAKE_CURRENT_SOURCE_DIR}/dbusinterface/xml ${CMAKE_CURRENT_SOURCE_DIR}/dbusinterface/generation_dbus_interface)

# Sources files
file(GLOB_RECURSE SRCS "*.h" "*.cpp"
    "../../widgets/*.h"
    "../../widgets/*.cpp"
    "../../frame/util/imageutil.h"
    "../../frame/util/imageutil.cpp"
    "../../frame/util/statebutton.h"
    "../../frame/util/statebutton.cpp"
    "../../frame/util/horizontalseperator.h"
    "../../frame/util/horizontalseperator.cpp"
    "../../frame/qtdbusextended/*.h"
    "../../frame/qtdbusextended/*.cpp")

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)

pkg_check_modules(XCB_LIBS REQUIRED IMPORTED_TARGET xcursor)
pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS})
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../quick-trays)
target_include_directories(${PLUGIN_NAME} PUBLIC ${DtkWidget_INCLUDE_DIRS}
  ../../interfaces
  ../../widgets
  ../../frame
  ../../frame/qtdbusextended
  ./dbusinterface/generation_dbus_interface
  componments)

target_link_libraries(${PLUGIN_NAME} PRIVATE
  ${DtkWidget_LIBRARIES}
  PkgConfig::QGSettings
  PkgConfig::XCB_LIBS
  Qt5::Widgets
  Qt5::DBus
  Qt5::Svg)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins/quick-trays)

=== plugins/multitasking/CMakeLists.txt ===

set(PLUGIN_NAME "multitasking")

project(${PLUGIN_NAME})

# Sources files
file(GLOB SRCS "*.h" "*.cpp" "../../widgets/tipswidget.h" "../../widgets/tipswidget.cpp"
"../../frame/util/imageutil.h" "../../frame/util/imageutil.cpp")

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)

pkg_check_modules(XCB_LIBS REQUIRED IMPORTED_TARGET xcursor)

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} resource.qrc)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../)
target_include_directories(${PLUGIN_NAME} PUBLIC ${DtkWidget_INCLUDE_DIRS} ../../interfaces)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    PkgConfig::XCB_LIBS
    Qt5::Widgets
    Qt5::DBus
    Qt5::Svg)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins)

=== plugins/notification/CMakeLists.txt ===
set(PLUGIN_NAME "notification")
find_package(Qt5 REQUIRED COMPONENTS DBus)
find_package(Dtk REQUIRED COMPONENTS Widget)

add_library(${PLUGIN_NAME} SHARED
    notification.h
    notification.cpp
    notificationplugin.h
    notificationplugin.cpp
    ${CMAKE_SOURCE_DIR}/widgets/tipswidget.h
    ${CMAKE_SOURCE_DIR}/widgets/tipswidget.cpp
    notification.qrc
)
target_compile_definitions(${PLUGIN_NAME} PRIVATE QT_PLUGIN)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)

target_include_directories(${PLUGIN_NAME} PRIVATE
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/interfaces>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/widgets>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/frame/qtdbusextended>
)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    Dtk::Widget
    Qt5::DBus
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins)

=== plugins/onboard/CMakeLists.txt ===

set(PLUGIN_NAME "onboard")

project(${PLUGIN_NAME})

# Sources files
file(GLOB_RECURSE SRCS "*.h"
    "*.cpp"
    "../../widgets/tipswidget.h"
    "../../widgets/tipswidget.cpp"
    "../../frame/qtdbusextended/*.h"
    "../../frame/qtdbusextended/*.cpp")

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkWidget REQUIRED)

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} onboard.qrc)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../)

target_include_directories(${PLUGIN_NAME} PUBLIC ${Qt5DBus_INCLUDE_DIRS}
    ../../interfaces
    ../../frame/qtdbusextended)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    Qt5::Widgets
    Qt5::DBus
    Dtk::Gui)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins)

=== debian/changelog ===
dde-dock (6.0.37) unstable; urgency=medium

  * release 6.0.37
  * fix linuxdeepin/developer-center#7612

 -- Mike Chen <chenke@deepin.org>  Wed, 03 Apr 2024 10:22:29 +0800

dde-dock (6.0.36) unstable; urgency=medium

  * release 6.0.36
  * fix linuxdeepin/developer-center#7222
  * fix linuxdeepin/developer-center#7207
  * fix linuxdeepin/developer-center#6454

 -- Mike Chen <chenke@deepin.org>  Wed, 06 Mar 2024 16:50:36 +0800

dde-dock (6.0.35) unstable; urgency=medium

  * feat: adjust dock ui

 -- tsic404 <liuheng@deepin.org>  Thu, 01 Feb 2024 10:58:27 +0800

dde-dock (6.0.34) unstable; urgency=medium

  * fix: dock animation broken (https://github.com/linuxdeepin/developer-center/issues/7143)
  * fix: dock plugin calculated to an incorrect size (https://github.com/linuxdeepin/developer-center/issues/7127)
  * fix: dock will not auto hide after set size (https://github.com/linuxdeepin/developer-center/issues/7129)
  * fix: dock plugin unable to click when in keep hide (https://github.com/linuxdeepin/developer-center/issues/7132)
  * fix: dock item indicator not update (https://github.com/linuxdeepin/developer-center/issues/7097)

 -- tsic404 <liuheng@deepin.org>  Tue, 30 Jan 2024 16:17:59 +0800

dde-dock (6.0.33) unstable; urgency=medium

  * fix: tmp block uosai in quickpanel

 -- tsic404 <liuheng@deepin.org>  Fri, 26 Jan 2024 14:38:06 +0800

dde-dock (6.0.32) unstable; urgency=medium

  * fix: dock get max size when positionChanged and KeepHide mode (https://github.com/linuxdeepin/developer-center/issues/7040)
  * fix: dock not remove plugin when fcitx exit (https://github.com/linuxdeepin/developer-center/issues/7080)
  * fix: dock theme not follow system (https://github.com/linuxdeepin/developer-center/issues/7090)

 -- tsic404 <liuheng@deepin.org>  Thu, 25 Jan 2024 14:30:26 +0800

dde-dock (6.0.31) unstable; urgency=medium

  * fix: error datetime tooltip (https://github.com/linuxdeepin/developer-center/issues/7056)
  * fix: unable get docked entriy by soft link path (https://github.com/linuxdeepin/developer-center/issues/7033)

 -- tsic404 <liuheng@deepin.org>  Tue, 23 Jan 2024 17:43:44 +0800

dde-dock (6.0.30) unstable; urgency=medium

  * chore: remove Cooperation in display plugin (https://github.com/linuxdeepin/developer-center/issues/7023)

 -- chenhongtao <chenhongtao@deepin.org>  Mon, 22 Jan 2024 17:27:34 +0800

dde-dock (6.0.29) unstable; urgency=medium

  * fix: when no timeformat, tooltip is empty

 -- chenhongtao <chenhongtao@deepin.org>  Mon, 22 Jan 2024 09:47:21 +0800

dde-dock (6.0.28) unstable; urgency=medium

  * fix: the item that removed is exist yet (https://github.com/linuxdeepin/developer-center/issues/4631)
  * fix: dock wakeup area not changed (https://github.com/linuxdeepin/developer-center/issues/5831)
  * fix: onboard not to show on first click (https://github.com/linuxdeepin/developer-center/issues/6675)
  * fix: timedate tips show error (https://github.com/linuxdeepin/developer-center/issues/6674)
  * fix: quickpanel icon not follow theme (https://github.com/linuxdeepin/developer-center/issues/6263)
  * fix: disable resize of dock popup window (https://github.com/linuxdeepin/developer-center/issues/6264)
  * feat: add dbus property window margin

 -- tsic404 <liuheng@deepin.org>  Thu, 18 Jan 2024 09:57:27 +0800

dde-dock (6.0.27) unstable; urgency=medium

  * fix: dock get stucked when launching (https://github.com/linuxdeepin/developer-center/issues/6657)
  * chore: make uosai default on dock (https://github.com/linuxdeepin/developer-center/issues/6486)
  * chore: open deepin-calendar instead of dde-widgets when click timedate (https://github.com/linuxdeepin/developer-center/issues/6696)
  * fix: item context menu not updated
  * feat: add plugin notification (https://github.com/linuxdeepin/developer-center/issues/6695)
  * fix: mainwindow hide when popup opens (https://github.com/linuxdeepin/developer-center/issues/4970)

 -- tsic404 <liuheng@deepin.org>  Tue, 09 Jan 2024 13:33:18 +0800

dde-dock (6.0.26) unstable; urgency=medium

  * release 6.0.26
  * fix #6033 #5719 #5786 #4331

 -- mike <chenke@deepin.org>  Fri, 29 Dec 2023 11:27:59 +0800

dde-dock (6.0.25) unstable; urgency=medium

  * chore: turn on bluetooth loading animation when not start
  * fix: fix again set dcc dock plugin icon pixelated

 -- chenhongtao <chenhongtao@deepin.org> Wed, 13 Dec 2023 15:31:57 +0800

dde-dock (6.0.24) unstable; urgency=medium

  * chore: use system icon first
  * fix: dcc dock plugin icon pixelated
  * fix some coredump issue
  * fix: brightness silder cannot sroll when is 28
  * tidy up some log

 -- chenhongtao <chenhongtao@deepin.org> Tue, 28 Nov 2023 10:51:52 +0800

dde-dock (6.0.23) unstable; urgency=medium

  * fix: displayplugin disappear when monitor count changed
  * fix: tray disappear when drag finished
  * fix: double tray show afeter drag into expandTray and drag back
  * chore: remove unused dbus
  * chore: Adapt time format feature(Issue: https://github.com/linuxdeepin/developer-center/issues/5902)

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 26 Oct 2023 17:25:38 +0800

dde-dock (6.0.22) unstable; urgency=medium

  * fix: a space on tray without trash show
  * fix: coredump empty tray when switch postion
  * fix: Can't hide when DockPopupWindow deactivate(Issue: https://github.com/linuxdeepin/developer-center/issues/5405)
  * fix: datetime size error
  * fix: tool appAreaWidget visible

 -- tsic404 <liuheng@deepin.org>  Mon, 11 Sep 2023 13:14:25 +0800

dde-dock (6.0.21) unstable; urgency=medium

  * fix: add lost windowSizeChanged Signal
  * fix: brightness update, update main view slider
  * chore: make trash not display in default
  * fix: click preview container not active window
  * feat: Remove dock-hotspot-plugin by Conflicts
  * feat: use new am dbus interface
  * feat: when new am avaliable do not load custom desktopfile
  * fix: dock coredump when update recentApp invisible


=== debian/control ===
Source: dde-dock
Section: x11
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
 cmake,
 debhelper-compat (= 10),
 extra-cmake-modules,
 libdbusmenu-qt5-dev,
 libdtkcore-dev (>=5.4.14),
 libdtkcore5-bin (>=5.4.14),
 libdtkgui-dev (>=5.4.13),
 libdtkwidget-dev (>=5.4.19),
 libdwayland-dev,
 libgmock-dev,
 libgsettings-qt-dev,
 libgtest-dev,
 libqt5svg5-dev,
 libqt5waylandclient5-dev,
 libqt5x11extras5-dev,
 libxcb-composite0-dev,
 libxcb-damage0-dev,
 libxcb-ewmh-dev,
 libxcb-icccm4-dev,
 libxcb-image0-dev,
 libxcursor-dev,
 libxdamage-dev,
 libxres-dev,
 libxtst-dev,
 pkg-config,
 qt5-qmake,
 qtbase5-private-dev,
 qttools5-dev,
 qttools5-dev-tools,
 qtwayland5-private-dev,
Standards-Version: 3.9.8
Homepage: http://www.deepin.org/

Package: dde-dock
Architecture: any
Depends:
 dbus-bin,
 dde-daemon (>=5.13.12),
 dde-qt5xcb-plugin (>=5.0.25),
 deepin-desktop-schemas (>=5.9.14),
 lastore-daemon (>=5.2.9),
 qtxdg-dev-tools,
 startdde (>=5.8.9),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 dde-disk-mount-plugin,
 dde-dock-onboard-plugin,
 dde-network-dialog,
 dock-network-plugin,
Conflicts:
 dde-dock-applets,
 dde-trash-plugin,
 dde-workspace (<< 2.90.5),
 dock-hotspot-plugin,
Replaces:
 dde-dock-applets,
 dde-trash-plugin,
Description: deepin desktop-environment - dock module
 Dock module of deepin desktop-environment

Package: dde-dock-dev
Architecture: any
Depends:
 ${misc:Depends},
Description: deepin desktop-environment - dock module development files
 Dock module development files of deepin desktop-environment

Package: dde-dock-onboard-plugin
Architecture: any
Depends:
 onboard,
 ${misc:Depends},
 ${shlibs:Depends},
Description: deepin desktop-environment - dock plugin for onboard
 Dock plugin for onboard of deepin desktop-environment
